
import com.xfactorstudio.ahawasi.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Xfactorstudio
 * @author Neeld Tanksley
 * @version 1.0
 */


public class XServerMessageHandler extends GenericMessageHandler{


  public XServerMessageHandler() {
    super();
  }
  public void onConnect(){
	//System.out.println("entering on connect");
  
  
  	// create and send <control type="setUserId" userId="someID"/>
    XMLElement XML = new XMLElement();
    XML.setTagName("control");
    XML.addProperty("type","setUserId");
    XML.addProperty("userId",request.getUserID());
    response.send(XML.toString());
	
	
	// create and send <control type="message" from="XServer" messvalue="Powered by Ahawasi v0.0.1"/>
    XML = new XMLElement();
    XML.setTagName("control");
    XML.addProperty("type","message");
    XML.addProperty("from","XServer");
    XML.addProperty("messvalue","Powered by Ahawasi v1");
    response.send(XML.toString());
	// create and send <control type="message" from="XServer" messvalue="Copyright 2000 XFactorStudio.com"/>
    XML.addProperty("messvalue","Copyright 2000 XFactorStudio.com");
    response.send(XML.toString());
    
	
	// create and send <control type="message" from="The Welcome message for this service"/>
    XML = new XMLElement();
	XML.setTagName("control");
	XML.addProperty("type","message");
    XML.addProperty("from","XServer");
	XML.addProperty("messvalue",request.getApplicationVariable("welcomeMessage"));
    response.send(XML.toString());
	//System.out.println(">>>" + XML.toString());
	
    //Send a client list to all in room
	//System.out.println("about to send all");
    response.sendToAll(request.getClientList().toXML());
	//System.out.println("leaving on connect");

  }//end onConnect

  public void onDisconnect(){
    response.sendToAll(request.getClientList().toXML());
  }//end onDisconnect

  public void onMessage(String message){
  	//System.out.print("got message");
    XMLElement XML = new XMLElement();
    XML.parseString(message,0);
    String nodeName = XML.getTagName();

    if (nodeName.equalsIgnoreCase("control")){
      String type = XML.getProperty("type");

      if (type.equalsIgnoreCase("getClientList")){
        response.send(request.getClientList().toXML());

      }else if (type.equalsIgnoreCase("login")){
        response.setUserName(XML.getProperty("username"));
        XMLElement XMLout = new XMLElement();
        XMLout.setTagName("control");
        XMLout.addProperty("type","message");
        XMLout.addProperty("messvalue",request.getUserName() + " has entered the room");
        response.sendToAll(XMLout.toString());
        response.sendToAll(request.getClientList().toXML());
      }

    }else if (nodeName.equalsIgnoreCase("message")){

      if (XML.getProperty("to") != null){
        response.sendTo(message,Long.parseLong(XML.getProperty("to")));

      }else{
        response.sendToAll(message);
      }

    }

  }//end onMessage
}