package com.xfactorstudio.ahawasi;

import java.io.*;
import java.util.*;
/*
 * LogOutputStream.java
 *
 *
 * Copyright (C) 2001 Neeld Tanksley
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 

/**
 *
 *
 * The LogWriter 
 *
 * @author Neeld Tanksley
 * @version .91
 */


public class LogOutputStream extends FileOutputStream 
{
	
	public LogOutputStream(String fileName)	throws FileNotFoundException{
			super(fileName,true);
	}
	
	
	public void println(String message)	{
		this.addEntry(message + System.getProperty("line.separator"));
	}
	
	public void print(String message){
		this.addEntry(message);
	}
	
	public void addEntry(String message){
		try	{
			message = this.markTime() + " -- " + message;
			this.write(message.getBytes());
		}catch(IOException ioe)	{
			ioe.printStackTrace(System.out);
		}	
	}

	
	public String markTime(){
		Calendar cal = Calendar.getInstance();
		return cal.getTime().toString();
	}


}