package com.xfactorstudio.ahawasi;

import java.util.Hashtable;

/*
 * Response.java
 *
 *
 * Copyright (C) 2001 Neeld Tanksley
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 

/**
 *
 *
 * The Response Object provided to all message handlers
 *
 * @author Neeld Tanksley
 * @version .91
 */

public class Response {
  private SocketService service;
  private ClientThread client;
  private Ahawasi server;

  public Response(Ahawasi server,SocketService service,ClientThread client) {
    this.service = service;
    this.client = client;
    this.server = server;
  }
  
  public void disconnect() {
  	client.kill();
  }
  
  /**
  *	Sends message to this client
  **/
  public void send(String message){
    client.send(message);
  }
  /**
  *	Sends message to this client
  **/
  public void send(XMLElement message){
    client.send(message.toString());
  }
  /**
  *	Sends message to client identified by userID
  **/
  public void sendTo(String message,long userID){
    service.sendTo(message,userID);
  }
  /**
  *	Sends message to client identified by userID
  **/
  public void sendTo(XMLElement message,long userID){
    service.sendTo(message.toString(),userID);
  }
  /**
  *	Sends message to client identified by userName
  **/
  public void sendTo(String message,String userName){
    service.sendTo(message,userName);
  }
  /**
  *	Sends message to client identified by userName
  **/
  public void sendTo(XMLElement message,String userName){
    service.sendTo(message.toString(),userName);
  }
 /**
  *	Sends message to all clients connected to this port
  **/
  public void sendToAll(String message){
    service.sendToAll(message);
  }
 /**
  *	Sends message to clients connected to this port
  **/
  public void sendToAll(XMLElement message){
    service.sendToAll(message.toString());
  }

  public void setServerVariable(String varName,String varValue){
    Hashtable serverVariables = server.getServerVariables();
    serverVariables.put(varName,varValue);
  }
  
  public void setApplicationVariable(String varName,String varValue){
    Hashtable applicationVariables = service.getApplicationVariables();
    applicationVariables.put(varName,varValue);
  }
  
  public void setSessionVariable(String varName,String varValue){
    Hashtable sessionVariables = client.getSessionVariables();
    sessionVariables.put(varName,varValue);
  }
  
  public void setUserName(String userName){
   client.setUserName(userName);
  }

}