package com.xfactorstudio.ahawasi;

import java.io.*;
import java.net.Socket;
import java.net.*;

/*
 * ServiceListServer.java
 *
 *
 * Copyright (C) 2001 Neeld Tanksley
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 

/**
 *
 *
 * The simple "http" server that provides a list of running services
 *
 * @author Neeld Tanksley
 * @version .91
 */

public class ServiceListServer extends Thread{
		private int filelistPort;
        private ServiceList serviceList;
        private boolean listening = true;
        private ServerSocket ss;
        private Ahawasi server;

        public ServiceListServer(Ahawasi server){
                this.server = server;
                this.filelistPort = server.getServiceListPort();
                this.serviceList = server.getServiceList();
	}
        public void close(){
          listening = false;
          try{
            ss.close();
          }catch(Exception e){}
        }

	public synchronized void run(){
		try{
		ss = new ServerSocket(filelistPort);
		server.out.println("ServiceListServer listening on port " + filelistPort);
                        while(listening){
				Socket client = ss.accept();
				BufferedReader in = new BufferedReader(new InputStreamReader(client.getInputStream()));
				PrintWriter out = new PrintWriter(new OutputStreamWriter(client.getOutputStream()));

                                String line;
				while((line = in.readLine()) != null){
                                  if (line.length() == 0) break;
				}
				out.println("HTTP/1.0 200");
				out.println("Content-Type: text/xml");
				out.println();
				out.flush();
				
				if(Ahawasi.configurator.getServiceListDetail()){
                	out.print(serviceList.toXMLDetailed());
				}else{
					out.print(serviceList.toXML());
				}

		  		out.close();
			}
		} catch (Exception e){
			e.printStackTrace(new PrintStream(server.err));
		}finally{
		}
	}
}